/* LSDADecoder
Copyright (C) 2019  Pavel Cernohorsky

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <https://www.gnu.org/licenses/>.*/

#pragma once

#include <stdexcept>

class Endian
{
public:
  template <typename T>
  static T swap(T val)
  {
    static_assert(sizeof(T) > 1, "Cannot swap endian - one byte value.");
    static_assert(!(sizeof(T) % 2), "Cannot swap endian - non-even number of bytes.");
    T result;
    unsigned char* src = reinterpret_cast<unsigned char*>(&val) + sizeof(T) - 1;
    unsigned char* dst = reinterpret_cast<unsigned char*>(&result);
    for (size_t i = 0; i < sizeof(T); ++i)
    {
      *(dst++) = *(src--);
    }
    return result;
  }
};
