/* LSDADecoder
Copyright (C) 2019  Pavel Cernohorsky

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <https://www.gnu.org/licenses/>.*/

#include "GeneralPrinter.h"

#include <iomanip>
#include <sstream>

std::string GeneralPrinter::printHex(const unsigned char* data, size_t size, bool prefix)
{
  std::ostringstream result;
  if (prefix)
  {
    result << "0x";
  }
  result << std::setfill('0') << std::uppercase;
  for (size_t i = 0; i < size; ++i)
  {
    result << std::setw(2) << std::hex << static_cast<int>(*data);
    ++data;
  }
  return result.str();
}