/* LSDADecoder
Copyright (C) 2019  Pavel Cernohorsky

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <https://www.gnu.org/licenses/>.*/

#pragma once

#include "Endian.h"

#include <string>

class GeneralPrinter
{
public:
  static std::string printHex(const unsigned char* data, size_t size, bool prefix);

//------------------------------------------------------------------------------

  template <typename T>
  static std::enable_if_t<sizeof(T) == 1, std::string> printHex(T val)
  {
    return printHex(reinterpret_cast<const unsigned char*>(&val), sizeof(T), true);
  }

//------------------------------------------------------------------------------

  template <typename T>
  static std::enable_if_t<sizeof(T) != 1, std::string> printHex(T val)
  {
    T newVal = Endian::swap(val);
    return printHex(reinterpret_cast<const unsigned char*>(&newVal), sizeof(T), true);
  }
};
